<?PHP
//	pdbc:      	 " simple database management interface "
//	Autor:       " Oliver Keller "
//  Name:        " Younik Network " 
//  Reference:   " http://www.younik.net " 
//	Date:        " 05.02.2006 "
//	Version:     " Revision 1.1 " 


	/*
	 *	function create
	 *
	 *	creates the object corresponding to the class,
	 *	set the global variables for the database
	 *	connection, and returns the object to the user.
	 *
	 *	interface:
	 *		create	->	database_object
	 */

	function create() {
	
		/*
		 *  These variables must be set by the user.
		 *	They will be needed for the database connection.
		 */
		 
			$hostname = "";
			$username = "";
			$password = "";
			$database = "";
			
			$hostname  = "localhost";
			$username  = "web226";
			$password  = "NhoSgDuM";
			$database  = "usr_web226_3";

			


		/*
		 *  Call to the selfCreator if requested
		 */
		
		 if ($_GET['create_file_from_db_data']) {
		 	create_file_from_db_data($hostname, $username, $password, $database);
		 }

			
		/*
		 *	Object creation and initialization
		 */
		 
		$pdbc_object = new pdbc();
		$pdbc_object->hostname = $hostname;
		$pdbc_object->username = $username;
		$pdbc_object->password = $password;
		$pdbc_object->database = $database;
		$pdbc_object->pdbc_initialization();
		
		return $pdbc_object;
	}



	/*
	 *	Class pdbc
	 *
	 *	manage your database requirements
	 *
	 */

	class pdbc extends fileUploadHandler {
	
	//	static settings		-----------------------------------------------------------------------------

		/*
		 *  The global variables, set by the user.
		 */
		 
		var $hostname;
		var $username;
		var $password;
		var $database;
		
		
		/*
		 *	Class pdbc
		 *
		 *	interface:
		 *		class dbHandler
		 *		class dbIterator        extends dbHandler
		 *		class fileHandler       extends dbIterator
		 *		class pictureHandler    extends fileHandler
		 *		class fileUploadHandler extends pictureHandler
		 */
		
		
	//	initialization		-----------------------------------------------------------------------------
	
		function pdbc_initialization() {
			parent::default_settings();
			$this->db_connect();
		}
		
	}	// class pdbc



	/*
	 *	Class dbHandler
	 *
	 *	initialize connection to database onLoad.
	 *
	 *	interface:
	 *		select();		->	$this->result;
	 *		insert();
	 *		update();
	 *		delete();
	 *		alter();
	 *
	 *		status();		->	$this->status
	 *
	 *		set_table();
	 *		set_sql_string();
	 */

	class dbHandler {		
		
	//	action		-----------------------------------------------------------------------------
		
		function select() {
			$select = mysql_query($this->sql_string);
			$this->make_result($select);
		}
								
		function insert() {
			$insert = mysql_query($this->sql_string);
		}
		
		function update() {
			$update = mysql_query($this->sql_string);
		}
		
		function delete() {
			$delete = mysql_query($this->sql_string);
		}
		
		function alter() {
			$alter = mysql_query($this->sql_string);
		}
		
			
	//	utilities	-----------------------------------------------------------------------------
				
		function make_result($select) {
			$i = 0;
			while($row = mysql_fetch_array( $select )) {
				for ($k = 0; $k < $this->attr_count; $k++) {
					$attribute = $this->attr_array[$k];
					$this->result[$i][$k] = $row["$attribute"];
				}
				$i++;
			}
			$this->tuple_count = $i;
		}

		function attribute_calculation() {
			$attributes = substr($this->sql_string, 6, strpos(strtolower($this->sql_string), "from ")-7);
			$this->attr_count = substr_count($attributes, ",") + 1;
			for ($k = 0; $k < $this->attr_count; $k++) {
				$current_komma = strpos($attributes, ",");
				if ($current_komma > 1) {
					$new_attribut = substr($attributes, 0, $current_komma);
					$attributes = substr($attributes, $current_komma+1);
				} else {
					$new_attribut = $attributes;
				}
				//	attribute as name
				if ($pos = strpos($new_attribut, " as ")){
					$pos = $pos + 4;
					$new_attribut = substr($new_attribut, $pos, strlen($new_attribut)-$pos);
				}				
				$this->attr_array[$k] = str_replace("distinct ", "", $new_attribut);
				if (substr($this->attr_array[$k],0,1) == " ") {$this->attr_array[$k] = substr($this->attr_array[$k],1);}
			}
		}
						
			
	//	connection	-----------------------------------------------------------------------------

		function db_connect() {
			if ($this->hostname != "" && $this->username != "" && $this->password != "" && $this->database != "") {
				$my_connection = mysql_connect($this->hostname,$this->username,$this->password);
				if ($my_connection) {
					if (mysql_select_db($this->database)) {
						$this->status = "connected to database"; 
					} else {
						$this->status = "database could not be found.";
					}
				} else {
					$this->status = "no connection to database.";
				}
			} else {
				$this->status = "missing login informations.";
			}
		}
		

	//	status		-----------------------------------------------------------------------------

		function status() {
			return $this->status;
		}
		
		
	//	settings	-----------------------------------------------------------------------------

		function default_settings() {
			$this->table        = "";
			$this->sql_string   = "";
			$this->status	    = "";
			$this->attr_count   = 0;	// number of attributs in request
			$this->tuple_count  = 0;	// number of tuples the database returns
		}
																				
		function set_table($table) {
			$this->table = $table;
		}
				
		function set_sql_string($query) {
			$this->sql_string = $query;
			$this->attribute_calculation();
		}
		
	}	// class dbHandler



	/*
	 *	Class dbIterator
	 *
	 *	provides an iterator over the query results.
	 *
	 *	interface:
	 *		item();				->	attribute
	 *		iterator();
	 *		next();
	 *		previous();
	 *		first();
	 *		last();
	 */

	class dbIterator extends dbHandler {		
		
	//	action		-----------------------------------------------------------------------------
		
		function item($attr_name) {
			if ($this->db_iterator >= 0) {
				$search = true;
				$position = -1;
				while ($search) {
					$position++;
					if ($this->attr_array[$position] == $attr_name) { $search = false; }
					elseif ($position > $this->attr_count) { return "no such attribute"; }
				}
				return $this->result[$this->db_iterator][$position];
			} else {
				return "no db iterator";
			}
		}
		
		function iterator($iterator_position=0) {
			if ($this->tuple_count > 0) {
				$this->db_iterator = $iterator_position;
				if ($this->db_iterator == 0) {
					$this->iterator_is_first = true;
				} else {
					$this->iterator_is_first = false;
				}
				
				if ($this->db_iterator == $this->tuple_count) {
					$this->iterator_is_last  = true;
				} else {
					$this->iterator_is_last  = false;
				}
			} else {
				$this->db_iterator = -1;
			}
		}
		
		function next() {
			if ($this->db_iterator < $this->tuple_count-1 && $this->tuple_count > 0) {
				$this->iterator($this->db_iterator+1);
				return 1;
			} else {
				return 0;
			}
		}
		
		function previous() {
			if ($this->db_iterator > 0 && $this->tuple_count > 0) {
				$this->iterator($this->db_iterator-1);
				return 1;
			} elseif ($this->db_iterator == -1 && $this->tuple_count > 0) {
				$this->iterator($this->tuple_count-1);
				return 1;
			} else {
				return 0;
			}
		}
		
		function first() {
			if ($this->tuple_count > 0) {
				$this->iterator(0);
				return 1;
			} else {
				$this->db_iterator = -1;
				return 0;
			}
		}
		
		function last() {
			if ($this->tuple_count > 0) {
				$this->iterator($this->tuple_count-1);
				return 1;
			} else {
				$this->db_iterator = -1;
				return 0;
			}
		}
				

	//	settings	-----------------------------------------------------------------------------

		function default_settings() {
			parent::default_settings();
			$this->db_iterator = -1;
			$this->iterator_is_first = false;
			$this->iterator_is_last  = false;
		}
		
	}	// class dbIterator



	/*
	 *	Class fileHandler
	 *
	 *	interface:
	 *		get_file();
	 *		get_all_files();
	 */

	class fileHandler extends dbIterator {		
		
	//	action		-----------------------------------------------------------------------------
		
		function get_file($id) {
			$path = "-";
			if (file_exists('lib/pdbc.php')) {	$path = "lib/";	} 
			elseif (file_exists('../lib/pdbc.php')) {	$path = "../lib/";	} 
			elseif (file_exists('../../lib/pdbc.php')) {	$path = "../../lib/";	} 
			elseif (file_exists('../../../lib/pdbc.php')) {	$path = "../../../lib/";	} 
			
			if ($path != "-") { return $path."pdbc.php?create_file_from_db_data=1&id=$id&table=$this->table"; }
			else { return "filepath could not be found"; }
		}
		
		function get_all_files() {
			$this->set_sql_string("SELECT $this->file_attributes FROM $this->database.$this->table ORDER BY id ASC");
			$this->select();
		}

		
	//	settings		-----------------------------------------------------------------------------

		function default_settings() {
			parent::default_settings();
			$this->file_attributes = "id, name, date, type, comment";
		}

	}	// class fileHandler



	/*
	 *	Class pictureHandler
	 *
	 *	interface:
	 *		show_pic();		->	print picture_file
	 *
	 *		get_first();
	 *		get_last();	
	 *		get_next();
	 *		get_previous();
	 *
	 *		set_with_id();	
	 *		set_first();
	 *		set_last();
	 *
	 *		counter();
	 *		is_first();		->	is_first;
	 *		is_last();		->	is_last;
	 */
	 
	class pictureHandler extends fileHandler {
					
	//	action		-----------------------------------------------------------------------------
		
		function show_pic() {
			echo $this->get_file($this->fileID);
		}
		

	//	catcher		-----------------------------------------------------------------------------

		function get_first() {
			$select = mysql_query("SELECT $this->download_attributes FROM $this->database.$this->table WHERE type LIKE 'image/%' ORDER BY id ASC");
			$row = mysql_fetch_array($select);
			$this->firstFileID = $row["id"];
		}
		
		function get_last() {
			$select = mysql_query("SELECT $this->download_attributes FROM $this->database.$this->table WHERE type LIKE 'image/%' ORDER BY id DESC");
			$row = mysql_fetch_array($select);
			$this->lastFileID = $row["id"];
		}
		
		function get_next() {
			if ($this->is_last != 1) {
				$select = mysql_query("SELECT $this->download_attributes FROM $this->database.$this->table WHERE type LIKE 'image/%' ORDER BY id ASC");
				$i = 0;
				while($row = mysql_fetch_array($select)) {
					if ($row["id"] == $this->fileID) {
						$i = 1;
					} elseif ($i == 1) {
						$this->nextFileID = $row["id"];
						$i = 0;
					}
				}
			} else {
				$this->get_first();
				$this->nextFileID = $this->firstFileID;
			}
		}

		function get_previous() {
			if ($this->is_first != 1) {
				$select = mysql_query("SELECT $this->download_attributes FROM $this->database.$this->table WHERE type LIKE 'image/%' ORDER BY id DESC");
				$i = 0;
				while($row = mysql_fetch_array($select)) {
					if ($row["id"] == $this->fileID) {
						$i = 1;
					} elseif ($i == 1) {
						$this->previousFileID = $row["id"];
						$i = 0;
					}
				}
			} else {
				$this->get_last();
				$this->previousFileID = $this->lastFileID;
			}
		}
		

	//	setter		-----------------------------------------------------------------------------

		function set_with_id($id) {
			$this->set_picture($id);
			$this->get_first();
			$this->get_last();
			$this->check_first();
			$this->check_last();
		}

		function set_first() {
			$this->is_first = 1;
			$this->get_first();
			$this->get_last();
			$this->set_picture($this->firstFileID);
			$this->check_last();
		}
		
		function set_last() {
			$this->is_last = 1;
			$this->get_first();
			$this->get_last();
			$this->set_picture($this->lastFileID);
			$this->check_first();
		}
		
		function set_picture($id) {
			$select = mysql_query("SELECT $this->download_attributes FROM $this->database.$this->table WHERE id=$id");
			while($row = mysql_fetch_array($select)) {
				$this->fileName    = $row["name"];
				$this->fileType    = $row["type"];
				$this->fileComment = $row["comment"];
				$this->fileData    = $row["data"];
				$this->fileID      = $row["id"];
			}
		}
		

	//	utilities		-----------------------------------------------------------------------------

		function check_first() {
			if ($this->fileID == $this->firstFileID) {
				$this->is_first = 1;
			}
		}

		function check_last() {
			if ($this->fileID == $this->lastFileID) {
				$this->is_last = 1;
			}
		}
		
		function is_first()  {
			return $this->is_first;
		}
		
		function is_last()  {
			return $this->is_last;
		}
		
		function counter() {
			$select = mysql_query("SELECT count(*) as number FROM $this->database.$this->table WHERE type LIKE 'image/%'");
			$row = mysql_fetch_array($select);
			$this->number  = $row["number"];
			if ($this->number == 1) {
				$this->is_last  = 1;
				$this->is_first = 1; 
			}
		}
		
		
	//	settings		-----------------------------------------------------------------------------

		function default_settings() {
			parent::default_settings();
			$this->number   = 0;
			$this->is_first = 0;
			$this->is_last  = 0;
			$this->download_attributes = "id, name, type, comment, data";
			$this->get_current_file_id();
		}
		
		function get_current_file_id() {
			if ($_POST['file_id'] > 0) {
				$this->fileID = $_POST['file_id'];
			} elseif ($_GET['file_id'] > 0) {
				$this->fileID = $_GET['file_id'];
			}
		}

	}	// class pictureHandler



	/*
	 *	Class fileUploadHandler
	 *
	 *	interface:
	 *		upload();
	 *
	 *		set_type();
	 *		set_comment();	
	 */

	class fileUploadHandler extends pictureHandler {
					
	//	action		-----------------------------------------------------------------------------
		
		function upload($post_file_name) {
			$this->tmpFile   = $_FILES["$post_file_name"]['tmp_name'];
			$this->fileName  = $_FILES["$post_file_name"]['name'];	
			$this->fileType  = $_FILES["$post_file_name"]['type']; 	
			
			$this->fileDate  = strftime("%Y-%m-%d");
			$this->comment   = $_POST['comment'];
			
			$this->fileName  = str_replace(" ", "_", $this->fileName);
			$this->fileBytes = fopen($_FILES["$post_file_name"]['tmp_name'], "rb");
			$this->fileBytes = addslashes(fread($this->fileBytes, filesize($_FILES["$post_file_name"]["tmp_name"])));
       		unlink($_FILES["$post_file_name"]["tmp_name"]);
			
//			if(filesize($this->tmpFile) > 0) {
				if ($this->db_type_check($this->required_type, $this->fileType)) {
					$this->copy_file_into_db();
				}
//			}
		}
		
		function db_type_check($required_type, $file_type) {
			if ($required_type == "all") {
				return 1;
			} elseif ($required_type == "text") {
				if($file_type == "text/plain" || $file_type == "text/html") {
					return 1;
				} 
			} elseif ($required_type == "image") {
				if($file_type == "image/gif" || $file_type == "image/jpeg" || $file_type == "image/png") {
					return 1;
				}
			} else {return 0;}
		}
		
		function copy_file_into_db() {
			$insert = mysql_query("INSERT INTO $this->database.$this->table ($this->upload_attributes) VALUES ('$this->fileName', '$this->fileDate', '$this->fileType', '$this->comment', '$this->fileBytes')");				
		}

				
	//	settings		-----------------------------------------------------------------------------

		function default_settings() {
			parent::default_settings();
			$this->required_type = "all";
			$this->comment = "";
			$this->upload_attributes = "name, date, type, comment, data";
		}
		
		function set_type($type) {
			if ($type == "all" || $type == "text" || $type == "image") {
				$this->required_type = $type;
			}
		}
		
		function set_comment($comment) {
			$this->comment = $comment;
		}

	}	// class fileUploadHandler
	
	
	
	/*
	 *	function: create_file_from_db_data();
	 *
	 *	pretends the data, and exit.
	 */
	 
	 function create_file_from_db_data($hostname, $username, $password, $database) {
	 	$table = $_GET['table'];
		$id    = $_GET['id'];
		
		if (mysql_connect($hostname, $username, $password)) {
			if (mysql_select_db($database)) {
				$query = mysql_fetch_array(mysql_query("SELECT name, type, data FROM $database.$table WHERE id=$id"));
				header("Content-type: ".$query['type']);
				header("Content-Disposition: filename=".$query['name']);
				echo $query['data'];
				exit(0);
			}
		}
	 }


	/*
	 *	selfCreator initializer
	 */
	 
	if ($_GET['create_file_from_db_data']) {
		create();
	}


?>